diff -a -x CVS -x Root -x Repository -x Tag -x Entries -x Entries.Log -x .svn -x '*.rej' -x '*.orig' -x .cvsignore -N -r -u ./src/daemon/common/commonSwarming.ml ./src/daemon/common/commonSwarming.ml
--- ./src/daemon/common/commonSwarming.ml	2006-05-20 01:43:54.000000000 +0200
+++ ./src/daemon/common/commonSwarming.ml	2006-05-25 20:48:14.000000000 +0200
@@ -17,6 +17,32 @@
     Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *)
 
+(*
+  The jobs of swarmers are :
+  * select what data to ask from each uploader
+  * merge data coming from uploaders, potentially from different
+  networks, into a single Unix32 backend.
+
+                            OVERALL SCHEMA
+
+Each network frontend can have a different (fixed) chunk size
+t1 +--------+--------+--------+--------+--------+--------+-------- chunks
+t2 +------+------+------+------+------+------+------+------+------ chunks
+
+ each block is contained in at most /\ chunk_of_block
+         one chunk, for any network ||                            mappings 
+                                    \/ blocks_of_chunk
+swarmer
+   +------+-+----+---+--+------+------++-----+--+---+----+-+------ blocks
+    |      | |    |   |  |      |    ...                      variable size
+    v      v v    v   v  v      v
+    r<>r   r r    r   r  r<>r   r<>r                               ranges
+                            ^                      one dbl linked list/block
+                            |                    encoding missing data ranges
+uploaders physically     uploader
+reference ranges
+*)
+
 open Int64ops
 open Options
 open Printf2
@@ -25,7 +51,6 @@
 
   
 let check_swarming = false
-let debug_present_chunks = false
 let debug_all = false
 
 open CommonTypes
@@ -37,11 +62,8 @@
 
 exception VerifierNotReady
 
-type chunks =
-  AvailableRanges of (int64 * int64) list
-(* A bitmap is encoded with '0' for empty, '1' for present '2' complete '3' verified *)
-| AvailableCharBitmap of string 
-(* A bitmap encoded as a bit vector *)
+type intervals =
+  AvailableIntervals of (int64 * int64) list
 | AvailableBitv of Bitv.t
 
 type verification =
@@ -63,7 +85,6 @@
 
 open CommonTypes
 
-open Int64ops
 open CommonFile
 open CommonTypes
 open CommonClient
@@ -91,6 +112,8 @@
 
 *)
 
+(* only used in code (currently disabled) for finding duplicate chunks *)
+
 type chunk = {
     chunk_uid : uid_type;
     chunk_size : int64;
@@ -100,20 +123,27 @@
 (* glossary:
    network frontend use "chunks" of data,
    swarmer use "blocks" of data *)
+(* frontends are compared using physical equality (==) *)
 type t = {
     mutable t_primary : bool;
     t_file : file;
     mutable t_s : swarmer;
-    t_block_size : int64;
+    t_chunk_size : int64;
 
     t_nchunks : int;
     mutable t_converted_verified_bitmap : string;
     mutable t_last_seen : int array;
-    mutable t_ncomplete_blocks : int;
-    mutable t_nverified_blocks : int;
+    mutable t_ncomplete_chunks : int;
+    mutable t_nverified_chunks : int;
 
-    mutable t_verifier : verification;
-    mutable t_verified : (int -> int -> unit);
+    mutable t_verifier : verification; (* information available to
+					  check data correctness *)
+    mutable t_verified : (int -> int -> unit); (* function to call
+						  when a chunk is verified;
+						  receives the number
+						  of verified chunks,
+						  and the index of the
+						  chunk just verified *)
 
 (* mapping from network chunks to swarmer blocks *)
     mutable t_blocks_of_chunk : int list array;
@@ -122,13 +152,12 @@
   }
 
 and swarmer = {
-    mutable s_num : int;
-    mutable s_filename : string;
+    s_num : int;
+    s_filename : string;
+    s_size : int64;
 
     mutable s_networks : t list; (** list of frontends, primary at head 
 				     t.t_s = s <=> t in s.s_networks *)
-    mutable s_size : int64;
-    mutable s_range_size : int64;
     mutable s_strategy : strategy;
 
     mutable s_verified_bitmap : string;
@@ -154,20 +183,21 @@
     mutable block_end : Int64.t;
     mutable block_ranges : range; (** [range] of the double-linked
 				      list of ranges associated to the
-				      [block] *)
-    mutable block_remaining : int64; (* unused ? *)
+				      [block] 
+				      what about using a standard list
+				      instead ? 
+				      or a balanced tree ? *)
+    mutable block_remaining : int64; (* amount of bytes missing. *)
   }
 
 and range = {
     mutable range_block : block;
-    mutable range_begin : Int64.t; (* official begin int64 *)
+    mutable range_begin : Int64.t;
     mutable range_end : Int64.t;
     mutable range_prev : range option;
     mutable range_next : range option;
-    mutable range_current_begin : Int64.t; (* current begin pos *)
-(*        mutable range_verified : bool; *)
-    mutable range_nuploading : int; (* current number of clients
-				       filling that range ? *)
+    mutable range_nuploading : int; (* number of uploaders currently
+				       referencing that range *)
   }
 
 and uploader = {
@@ -176,26 +206,33 @@
 
     mutable up_declared : bool;
 
-    mutable up_chunks : chunks;
+    mutable up_intervals : intervals;
     mutable up_complete_blocks : int array; (** block numbers *)
-    mutable up_ncomplete : int;
+    mutable up_ncomplete : int; (** number of blocks not yet handled,
+				    at the beginning of
+				    up_complete_blocks *)
 
     mutable up_partial_blocks : (int * int64 * int64) array; (** block
 								 number,
 								 begin_pos,
 								 end_pos
 								 *)
-    mutable up_npartial : int;
+    mutable up_npartial : int; (** number of blocks not yet handled,
+				   at the beginning of
+				   up_partial_blocks *)
 
     mutable up_block : block option;
     mutable up_block_begin : int64;
     mutable up_block_end : int64;
 
-    mutable up_ranges : (int64 * int64 * range) list;
+    mutable up_ranges : (int64 * int64 * range) list; (* ranges referenced by
+							 that uploader, see
+							 range_nuploading *)
   }
 
 (* range invariants: 
-   Ranges represent "holes" of missing data in a block.
+   Ranges represent "holes" of missing data in a block; Data is
+   missing between offsets range_begin and range_end.
 
    [block]'s [block_ranges] reference the first (smallest offsets) of
    the [range]s associated with it. 
@@ -214,12 +251,64 @@
    overlap, and are sorted in increasing offsets order:
 
    b.block_begin <= b.block_ranges.block_begin ... <=
-   r.range_prev.range_end <= r.range_begin <= r.range_current_begin <=
+   r.range_prev.range_end <= r.range_begin <=
    r.range_end <= r.range_next.range_begin <= ...
-   <= b.block_end
+   <= b.block_end *)
    
-   Role played by r.range_current_begin is unclear for now. *)
+(* range owners are only used thru uploaders.up_ranges. blocks could be
+   saved in [uploaders]' [up_ranges] along range, but would
+   need uploading when the swarmer is splitted.
+
+   Removing [range] from [up_ranges] and [range_nuploading] from
+   [range] could be good too, because they're not correctly updated
+   when the swarmer is splitted. Again, getting rid of them is a
+   problem of performance.
+*)
+
+(* block invariants
+   Data missing for a block is the sum of the "sizes" of its ranges.
+
+   b.block_remaining = sum (r.range_end - r.range_begin) b.block_ranges
+*)
+
+(* swarmer invariants ?
+   s.s_verified_bitmap.[i] = 0 <=> s_blocks.[i] = EmptyBlock
+   s.s_verified_bitmap.[i] = 1 <=> s_blocks.[i] = PartialBlock _
+   s.s_verified_bitmap.[i] = 2 <=> s_blocks.[i] = CompletedBlock
+   s.s_verified_bitmap.[i] = 3 <=> s_blocks.[i] = VerifiedBlock
+   If so, why not drop s_verified_bitmap, and replace it by some
+   verified_bitmap s i and verified_bitmap_all s functions ?
+*)
+
+(* frontend invariants ?
+   t_ncomplete_chunks = 
+   List.length (List.filter (fun x -> x >= '2') t_converted_verified_bitmap)
+   t_nverified_chunks = 
+   List.length (List.filter (fun x -> x = '3') t_converted_verified_bitmap)
+
+   hence t_ncomplete_chunks >= t_nverified_chunks
+
+   All chunks are [t_chunk_size] bytes in size, and first start at
+   offset 0. This is assumed in [create], [associate], [verify_chunk],
+   [duplicate_chunks], maybe more.
+*)
+
+(* uploaders invariants ?
+   uploader block numbers are stored in reverse order in
+   up_complete_blocks and up_partial_blocks (first blocks at the end
+   of arrays), then array is processed from end to begin.
+
+   0 <= up_ncomplete < Array.length up_complete_blocks 
+   0 <= up.up_npartial < Array.length up_partial_blocks
+
+   When a block has been selected, it's pushed out of the first
+   up_ncomplete first elements of up_complete_blocks by swapping it
+   with the #(up_ncomplete-1) element, then up_ncomplete is
+   decreased. (and similarly with s/complete/partial/ ?)
 
+   The question is now, aren't there better datastructures than
+   arrays for the job ? ;)
+*)
 
 (*************************************************************************)
 (*                                                                       *)
@@ -249,112 +338,52 @@
 
 let swarmer_counter = ref 0
 
-let has_multinet = true
-
-(*************************************************************************)
-(*                                                                       *)
-(*                         dummy_swarmer                                 *)
-(*                                                                       *)
-(*************************************************************************)
-
-let dummy_swarmer = {
-    s_num = 0;
-    s_filename = "";
-    s_networks = [];
-    s_size = zero;
-    s_range_size = zero;
-    s_strategy = AdvancedStrategy;
-    s_verified_bitmap = "";
-    s_blocks = [||];
-    s_block_pos = [||];
-    s_availability = [||];
-    s_nuploading = [||];
-  }
-
-(** (debug) output an [uploader] to current log *)
-
-let print_uploader up =
-  lprintf_n "  interesting complete_blocks: %d\n     " up.up_ncomplete;
-  Array.iter (fun i -> lprintf " %d " i) up.up_complete_blocks;
-  lprint_newline ();
-  lprintf_n "  interesting partial_blocks: %d\n     " up.up_npartial;
-  Array.iter (fun (i, begin_pos, end_pos) ->
-      lprintf " %d[%Ld...%Ld] " i begin_pos end_pos
-  ) up.up_partial_blocks;
-  lprint_newline ()
+let string_init n f =
+  let s = String.create n in
+  let rec aux i =
+    if i < n then begin
+      s.[i] <- f i;
+      aux (i+1)
+    end in 
+  aux 0;
+  s
+
+let string_iter f s =
+  let l = String.length s in
+  let rec aux i =
+    if i < l then begin
+      f i s.[i];
+      aux (i+1)
+    end in 
+  aux 0
+
+let string_existsi p s =
+  let l = String.length s in
+  let rec aux i =
+    i < l && (p i s.[i] || aux (i+1)) in
+  aux 0
+
+let string_for_all p s =
+  let l = String.length s in
+  let rec aux i =
+    i >= l || p s.[i] && aux (i+1) in
+  aux 0
 
 (** sets [t.t_last_seen] of the verified blocks to current time, and 
-    associated file's [t.t_file] last seen value to the oldest of the
+    associated file's [t.t_s.s_file] last seen value to the oldest of the
     remaining last seen values *)
 
 let compute_last_seen t =
   let last_seen_total = ref (BasicSocket.last_time ()) in
-  for i = 0 to String.length t.t_converted_verified_bitmap - 1 do
-    if t.t_converted_verified_bitmap.[i] > '2' then
+  string_iter (fun i c -> 
+    if c > '2' then
       t.t_last_seen.(i) <- BasicSocket.last_time ()
     else
       last_seen_total := min !last_seen_total t.t_last_seen.(i)
-  done;
+  ) t.t_converted_verified_bitmap;
   set_file_last_seen t.t_file !last_seen_total;
   t.t_last_seen
 
-(** if a swarmer is already associated with that [file_name], return it;
-    Otherwise create a new one with default values (including a default
-    [range_size] instead of the provided value ??) *)
-
-let create_swarmer file_name file_size range_size =
-
-  try
-    HS.find swarmers_by_name
-      { dummy_swarmer with
-      s_filename = file_name
-    }
-  with Not_found ->
-      incr swarmer_counter;
-
-(* Let be VERY conservative... *)
-      let range_size = edonkey_range_size in
-
-      let nchunks = 1 in
-      let rec s = {
-
-          s_num = !swarmer_counter;
-          s_filename = file_name;
-
-          s_networks = [];
-
-          s_size = file_size;
-          s_range_size = range_size;
-          s_strategy = AdvancedStrategy;
-
-          s_verified_bitmap = String.make nchunks '0';
-          s_blocks = Array.create nchunks EmptyBlock ;
-          s_block_pos = Array.create nchunks zero;
-          s_availability = Array.create nchunks 0;
-          s_nuploading = Array.create nchunks 0;
-(*      s_last_seen = Array.create nchunks 0; *)
-        }
-      in
-      HS.add swarmers_by_name s;
-      s
-
-(** (internal) return the offset of the end of the [i]th block of
-    swarmer [s] *)
-
-let compute_block_end s i =
-  let b = s.s_block_pos in
-  if Array.length b = i + 1 then
-    s.s_size
-  else
-    b.(i+1)
-
-(** (internal) return the offset of the beginning of the [i]th block
-    of swarmer [s] *)
-
-let compute_block_begin s i =
-  let b = s.s_block_pos in
-  b.(i)
-
 (** (internal) return a 0 sized range at offset [pos], and assigned to
     block [b] *)
 
@@ -366,19 +395,40 @@
       range_end = pos;
       range_block = b;
       range_nuploading = 0;
-      range_current_begin = pos;
     }
   in
   r
 
+let rec ranges_iter f r =
+  f r;
+  match r.range_next with
+  | None -> ()
+  | Some r ->
+      ranges_iter f r
+
+let rec ranges_fold f acc r =
+  let acc = f acc r in
+  match r.range_next with
+  | None -> acc
+  | Some rr -> ranges_fold f acc rr
+
+let rec ranges_for_all p r =
+  p r && 
+    (match r.range_next with
+     | None -> true
+     | Some r -> ranges_for_all p r)
+
+let block_ranges_for_all p b =
+  ranges_for_all p b.block_ranges
+
+let block_ranges_fold f acc b =
+  ranges_fold f acc b.block_ranges
+
 (** (internal) assigns range [r], and all other ranges along
     [range_next] links, to block [b] *)
 
 let rec own_ranges b r =
-  r.range_block <- b;
-  match r.range_next with
-    None -> ()
-  | Some r -> own_ranges b r
+  ranges_iter (fun r -> r.range_block <- b) r
 
 (** (internal) 
     Find ranges that are after [cut_pos] offset, unlink them from r
@@ -390,9 +440,7 @@
     If [cut_pos] is within one of the ranges, that range is cut in
     two at [cut_pos] offset, and link each half to its side.
 
-    What should happen to range_begin is unclear.
-
-    Also, what do to if range_nuploaders is not 0 ?
+    Also, what do to if range_nuploading is not 0 ?
     => [cut_ranges_after] is being called from [split_blocks] that
     does not preserve [s_nuploading] for blocks either
 *)
@@ -415,34 +463,165 @@
       (* "right" half *)
       let split_r = { r with
 	range_prev = None;
-	range_begin = cut_pos;
-	range_current_begin = max r.range_current_begin cut_pos
+	range_begin = max r.range_begin cut_pos
       } in
       (* "left" half *)
       r.range_next <- None;
       r.range_end <- cut_pos;
-      r.range_current_begin <- min r.range_current_begin cut_pos;
+      r.range_begin <- min r.range_begin cut_pos;
 
       if r.range_nuploading <> 0 then
-  lprintf_n "WARNING: Splitting a range currently being uploaded, don't know what to do with range_nuploaders :/\n";
+	lprintf_n "WARNING: Splitting a range currently being uploaded, don't know what to do with range_nuploading :/\n";
 
       split_r in
   let cut_ranges = iter r in
   own_ranges b cut_ranges;
   cut_ranges
   
+(** (internal) return the offset of the end of the [i]th block of
+    swarmer [s] *)
+
+let compute_block_end s i =
+  let b = s.s_block_pos in
+  if Array.length b = i + 1 then
+    s.s_size
+  else
+    b.(i+1)
+
+(** (internal) return the offset of the beginning of the [i]th block
+    of swarmer [s] *)
+
+let compute_block_begin s i =
+  let b = s.s_block_pos in
+  b.(i)
+
+(** Finds the number of the block containing [chunk_pos] offset, using
+    dichotomy. Blocks are half opened [block_begin, block_end[ *)
+
+(* 0 <= chunk_pos < s.s_size *)
+let compute_block_num s chunk_pos =
+  assert (0L <= chunk_pos && chunk_pos < s.s_size);
+  let b = s.s_block_pos in
+(* invariants:
+   0 <= min <= max <= Array.length b - 1
+   compute_block_begin s min <= chunk_pos < compute_block_end s max *)
+
+  let rec iter min max =
+    if min = max then min
+    else (* from now on, min < max *)
+      let medium = (min + max) / 2 in
+      (* Euclide        => 2*medium <= min + max <= 2*medium + 1 *)
+      (* min < max      => 2*min < min + max < 2*max
+                        => min <= medium < max                   *)
+      if min < medium then
+        if chunk_pos < b.(medium) then
+          iter min (medium - 1)
+        else
+          iter medium max
+      else
+        (* min = medium < max  => 2*min < min + max <= 2*min + 1
+                              <=>   min <       max <=   min + 1
+                              <=> min + 1 = max                  *)
+        if chunk_pos < b.(max) then
+          min else max
+  in
+  let i = iter 0 (Array.length b - 1) in
+  if debug_all then
+    lprintf_nl "%Ld is block %d [%Ld-%Ld]" chunk_pos i
+      (compute_block_begin s i) (compute_block_end s i);
+  i
+
 (** Return true if ranges fully "cover" their block
     ("the block is made of holes") *)
 
 let empty_block b =
   let rec iter begin_pos r =
-    r.range_current_begin = begin_pos &&
+    r.range_begin = begin_pos &&
     (match r.range_next with
-        Some rr -> iter r.range_end rr
-      | None -> r.range_end = b.block_end)
+     | Some rr -> iter r.range_end rr
+     | None -> r.range_end = b.block_end)
   in
   iter b.block_begin b.block_ranges
 
+let iter_intervals s f intervals =
+  let nchunks = Array.length s.s_blocks in
+  List.iter (fun (interval_begin, interval_end) ->
+    let interval_begin = min interval_begin s.s_size in
+    let interval_end = min interval_end s.s_size in
+(*  lprintf "apply on %Ld-%Ld\n" interval_begin interval_end; *)
+    if interval_begin < interval_end then
+      let i0 = compute_block_num s interval_begin in
+      let block_begin = compute_block_begin s i0 in
+      let rec iter_blocks i block_begin interval_begin =
+(*      lprintf "iter_blocks %d %Ld %Ld\n" i block_begin interval_begin; *)
+        if i < nchunks && block_begin < interval_end then
+          let block_end = compute_block_end s i in
+          let current_end =  min block_end interval_end in
+	  
+          if debug_all then
+            lprintf_nl "Apply: %d %Ld-%Ld %Ld-%Ld"
+              i block_begin block_end interval_begin current_end;
+	  
+          f i block_begin block_end interval_begin current_end;
+          iter_blocks (i+1) block_end block_end
+      in
+      iter_blocks i0 block_begin interval_begin
+  ) intervals
+
+(*************************************************************************)
+(*                                                                       *)
+(*                              Swarmers                                 *)
+(*                                                                       *)
+(*************************************************************************)
+
+let dummy_swarmer = {
+    s_num = 0;
+    s_filename = "";
+    s_size = zero;
+    s_networks = [];
+    s_strategy = AdvancedStrategy;
+    s_verified_bitmap = "";
+    s_blocks = [||];
+    s_block_pos = [||];
+    s_availability = [||];
+    s_nuploading = [||];
+  }
+
+(** if a swarmer is already associated with that [file_name], return it;
+    Otherwise create a new one with default values, that will be fixed
+    by the first frontend association *)
+
+let create_swarmer file_name file_size =
+  try
+    HS.find swarmers_by_name
+      { dummy_swarmer with
+	s_filename = file_name
+      }
+  with Not_found ->
+    incr swarmer_counter;
+
+    let nblocks = 1 in
+    let rec s = {
+
+      s_num = !swarmer_counter;
+      s_filename = file_name;
+      s_size = file_size;
+
+      s_networks = [];
+
+      s_strategy = AdvancedStrategy;
+
+      s_verified_bitmap = String.make nblocks '0';
+      s_blocks = Array.create nblocks EmptyBlock ;
+      s_block_pos = Array.create nblocks zero;
+      s_availability = Array.create nblocks 0;
+      s_nuploading = Array.create nblocks 0;
+(*      s_last_seen = Array.create nblocks 0; *)
+    }
+    in
+    HS.add swarmers_by_name s;
+    s
+
 (** Split swarmer existing blocks in at [chunk_size] boundaries *)
 let split_blocks s chunk_size =
 
@@ -488,7 +667,7 @@
 (* We need to split this block in two parts *)
         s.s_block_pos.(index_s) <- chunk_end;
         match s.s_blocks.(index_s) with
-          EmptyBlock | CompleteBlock | VerifiedBlock ->
+	| EmptyBlock | CompleteBlock | VerifiedBlock ->
 
 (* s.s_blocks.(index_s) will appear twice in the result list *)
             let new_blocks =  (
@@ -499,7 +678,6 @@
             iter index_s chunk_end new_blocks
 
         | PartialBlock b1 ->
-
 	    (* split b1 in two; b2 is the part after [chunk_end] offset *)
             let b2 = {
                 block_s = s;
@@ -533,12 +711,8 @@
                 s.s_verified_bitmap.[index_s] <- '0';
               end else
                 s.s_blocks.(index_s) <- PartialBlock b2;
-
             iter index_s chunk_end new_blocks
-
       end
-
-
   in
   let blocks = iter 0 zero [] in
 
@@ -552,9 +726,9 @@
     aux 0 in
 
   if array_exist ((<>) 0) s.s_availability then
-    lprintf_nl "WARNING: splitting swarmer discarded availability counters\n";
+    lprintf_nl "WARNING: splitting swarmer discarded availability counters";
   if array_exist ((<>) 0) s.s_nuploading then
-    lprintf_nl "WARNING: splitting a swarmer beging uploaded to\n";
+    lprintf_nl "WARNING: splitting a swarmer beging uploaded to";
 
   s.s_blocks <- Array.create nblocks EmptyBlock;
   s.s_verified_bitmap <- String.make nblocks '0';
@@ -569,8 +743,8 @@
     | (b, pos, c) :: tail ->
         begin
           match b with
-            PartialBlock b -> b.block_num <- i
-          | _ -> ()
+	  | PartialBlock b -> b.block_num <- i
+          | EmptyBlock | CompleteBlock | VerifiedBlock -> ()
         end;
         s.s_blocks.(i) <- b;
         s.s_verified_bitmap.[i] <- c;
@@ -583,21 +757,15 @@
 (** Associate a(n additional) frontend to a swarmer *)
 
 let associate is_primary t s =
-
 (* a swarmer cannot be associated more than once to a network *)
   if not (List.memq t s.s_networks) then
   let size = file_size t.t_file in
 
 (* what about raising an exception instead ? *)
-  if s.s_size <> size then
-    begin
-      lprintf_nl "file_size for %s does not match: swarmer %Ld / real %Ld" s.s_filename s.s_size size;
-      exit 2
-    end;
-
-  (* shouldn't just [t] be removed from the list ? *)
-  (* t.t_s.s_networks <- []; *)
-  t.t_s.s_networks <- List.filter ((!=) t) t.t_s.s_networks;
+  if s.s_size <> size then begin
+    lprintf_nl "file_size for %s does not match: swarmer %Ld / real %Ld" s.s_filename s.s_size size;
+    exit 2
+  end;
 
   t.t_s <- s;
   t.t_converted_verified_bitmap <- String.make t.t_nchunks '0';
@@ -610,17 +778,23 @@
     t.t_primary <- true;
     s.s_networks <- t :: s.s_networks;
   end else begin
-    t.t_primary <- false;
-    s.s_networks <- s.s_networks @ [t];
     (* TODO: transfer data into swarmer instead of discarding it *)
     Unix32.remove (file_fd t.t_file);
+    t.t_primary <- false;
+    s.s_networks <- s.s_networks @ [t];
   end;
+
+  (match s.s_networks with
+   | t :: tail ->
+       assert(t.t_primary);
+       List.iter (fun tt -> assert(not tt.t_primary)) tail
+   | [] -> assert false);
+
 (* at this point, we are supposed to split the blocks in the swarmer
 in smaller blocks depending on the block_size of this network, and compute
 the t_chunk_of_block and t_blocks_of_chunk fields. *)
 
-  let chunk_size = t.t_block_size in
-
+  let chunk_size = t.t_chunk_size in
   split_blocks s chunk_size;
 
   let nblocks = Array.length s.s_blocks in
@@ -630,7 +804,7 @@
       t.t_chunk_of_block <- Array.create nblocks 0;
       t.t_blocks_of_chunk <- Array.create nchunks [];
 
-      let chunk_size = t.t_block_size in
+      let chunk_size = t.t_chunk_size in
       for i = 0 to nblocks - 1 do
         let block_begin = compute_block_begin s i in
         let chunk = Int64.to_int (block_begin // chunk_size) in
@@ -644,42 +818,35 @@
     add_file_downloaded t.t_file (zero -- file_downloaded t.t_file);
 
 (* check that all frontends use the primary's file backend *)
-    begin
-      match s.s_networks with
-        t :: tail when is_primary ->
-          List.iter (fun tt ->
-              assert (not tt.t_primary);
-              set_file_fd tt.t_file (file_fd t.t_file)
-          ) tail
-
-      | tt :: tail when tt.t_primary ->
-          assert (not is_primary);
-          set_file_fd t.t_file (file_fd tt.t_file)
-      | _ -> ()
-    end;
-
-  ()
+  (match s.s_networks with
+   | t :: tail when is_primary ->
+       List.iter (fun tt ->
+         set_file_fd tt.t_file (file_fd t.t_file)
+       ) tail
+   | tprim :: tail ->
+       set_file_fd t.t_file (file_fd tprim.t_file)
+   | [] -> assert false)
 
 (** Create a primary frontend and its swarmer *)
 
 let create ss file chunk_size =
 
   let size = file_size file in
-  (* wrong if size is a multiple of chunk_size ? *)
+  (* wrong if size is a multiple of chunk_size, or on purpose ? *)
   let nchunks =
     1 + Int64.to_int (Int64.pred size // chunk_size) in
 
-  let rec t = {
+  let t = {
 
       t_s = ss;
       t_primary = true;
       t_file = file;
 
       t_nchunks = nchunks;
-      t_block_size = chunk_size;
+      t_chunk_size = chunk_size;
 
-      t_ncomplete_blocks = 0;
-      t_nverified_blocks = 0;
+      t_ncomplete_chunks = 0;
+      t_nverified_chunks = 0;
 
       t_converted_verified_bitmap = String.make nchunks '0';
       t_last_seen = Array.create nchunks 0;
@@ -694,117 +861,51 @@
   associate true t ss;
   t
 
+(** iter function f over all the blocks contained in the list of [intervals]
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         clear_uploader_ranges                         *)
-(*                                                                       *)
-(*************************************************************************)
-
-let clear_uploader_ranges up =
-  List.iter (fun (_,_,r) ->
-      r.range_nuploading <- r.range_nuploading - 1
-  ) up.up_ranges;
-  up.up_ranges <- []
-
-(*************************************************************************)
-(*                                                                       *)
-(*                         clear_uploader_block                          *)
-(*                                                                       *)
-(*************************************************************************)
-
-let clear_uploader_block up =
-  match up.up_block with
-    None -> ()
-  | Some b ->
-      up.up_block <- None;
-      let num = b.block_num in
-      let t = up.up_t in
-      let s = t.t_s in
-      s.s_nuploading.(num) <- s.s_nuploading.(num) - 1
-
-(** Finds the number of the block containing [chunk_pos] offset, using
-    dichotomy *)
-
-let compute_block_num s chunk_pos =
-  let b = s.s_block_pos in
-  let rec iter min max =
-    if min = max then min 
-    else
-      let medium = (min + max + 1) / 2 in
-      if chunk_pos < b.(medium) then
-	iter min (medium - 1)
-      else
-	let medium1 = medium + 1 in
-	if chunk_pos >= b.(medium1) then
-	  iter medium1 max
-	else
-	  medium
-  in
-  let i = iter 0 (Array.length b - 1) in
-  if debug_all then
-    lprintf_nl "%Ld is block %d [%Ld-%Ld]" chunk_pos i
-      (compute_block_begin s i) (compute_block_end s i);
-  i
-
-
-(*************************************************************************)
-(*                                                                       *)
-(*                         apply_intervals (internal)                    *)
-(*                                                                       *)
-(*************************************************************************)
+    f with receive block number, block beginning and ending offsets,
+    and overlapping interval beginning and ending offsets.
 
-let apply_intervals s f chunks =
-  let nchunks = Array.length s.s_blocks in
-  let rec iter chunks =
-    match chunks with
-      [] -> ()
-    | (chunk_begin, chunk_end) :: tail ->
-        let chunk_begin = min chunk_begin s.s_size in
-        let chunk_end = min chunk_end s.s_size in
-(*        lprintf "apply on %Ld-%Ld\n" chunk_begin chunk_end; *)
-        if chunk_begin < chunk_end then begin
-            let i0 = compute_block_num s chunk_begin in
-            let block_begin = compute_block_begin s i0 in
-            let rec iter_blocks i block_begin chunk_begin =
-
-(*              lprintf "iter_blocks %d %Ld %Ld\n" i block_begin chunk_begin; *)
-              if i < nchunks && block_begin < chunk_end then
-                let block_end = compute_block_end s i in
-
-                let current_end =  min block_end chunk_end in
-
-                if debug_all then
-                  lprintf_nl "Apply: %d %Ld-%Ld %Ld-%Ld"
-                    i block_begin block_end chunk_begin current_end;
-
-                f i block_begin block_end chunk_begin current_end;
-
-                iter_blocks (i+1) block_end block_end
-            in
-            iter_blocks i0 block_begin chunk_begin;
-          end;
-        iter tail
-  in
-  iter chunks
+    If an interval starts halfway of a block, iteration starts on the
+    next block, with interval_begin < block_begin indicating where the
+    interval really started.
+
+    If an interval ends halfway of a block, iteration ends on that
+    block, with interval_end < block_end indicating where the interval
+    really ended.
+*)
 
+let check_finished t =
+  let file = t.t_file in
+  match file_state file with
+  | FileNew 
+  | FileCancelled 
+  | FileAborted _ 
+  | FileShared 
+  | FileDownloaded 
+  | FileQueued 
+  | FilePaused -> 
+      false
+  | FileDownloading ->
+      if string_existsi (fun i c -> c <> '3')
+	t.t_converted_verified_bitmap then false
+      else begin
+        if file_size file <> file_downloaded t.t_file then
+          lprintf_nl "Downloaded size differs after complete verification";
+        true
+      end
 
-(*************************************************************************)
-(*                                                                       *)
-(*                         print_s                                       *)
-(*                                                                       *)
-(*************************************************************************)
+(** (debug) output a [swarmer] to current log *)
 
 let print_s str s =
   lprintf_nl "Ranges after %s:" str;
 
   let rec iter r =
-    lprintf_n " %Ld(%Ld)-%Ld(%d)"
-      r.range_begin r.range_current_begin r.range_end r.range_nuploading;
+    lprintf_n " %Ld-%Ld(%d)"
+      r.range_begin r.range_end r.range_nuploading;
     match r.range_next with
-      None -> lprint_newline()
-    | Some r -> iter r
-  in
+    | None -> lprint_newline ()
+    | Some r -> iter r in
 
   Array.iteri (fun i b ->
       lprintf_n "   %d: " i;
@@ -820,7 +921,7 @@
       ) s.s_networks;
 
       match b with
-        PartialBlock b ->
+      | PartialBlock b ->
           lprintf " [%Ld .. %Ld] --> "
             b.block_begin b.block_end;
           iter b.block_ranges
